<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php";
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

require_once $base_path_to_learning_resources . 'marksheet_template/marksheet_custom_styling/marksheet_custom_styling_function.php';
use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if (

    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken   = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid     = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username   = $jwt_validate->data->username;
$role       = $jwt_validate->data->role;

$specific_db_name = validateUserAccess(
    $conn_rjllearning,
    $userid,
    $role,
    $workspace_id,
    ['superadmin','admin'],
    null
);

if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

if ($postdata['function_type'] == "fetch_Custom_Stylesheet") {

    $institution_id = trim($postdata['institution_id']) ?? null;
    $branch_id = isset($postdata['branch_id']) && !empty($postdata['branch_id'])
        ? trim($postdata['branch_id'])
        : null;

    $custom_style = fetchActiveCustomStylesheets(
        $conn_rjllearning,
        $workspace_id,
        $institution_id,
        $branch_id
        
    );

    if ($custom_style) {
        successreturn($custom_style);
    } else {
        successreturn([]); // empty if nothing found
    }
}

?>
